
(* PRACTICA 5. DRIVER O PROGRAMA PRINCIPAL QUE USA
          LA IMPLEMENTACION DE UN SISTEMNA DE RESERVAS DE VUELOS
          PARA UN AEROPUERTO MEDIANTE UNA LISTA DE LISTAS *)

MODULE Dvuelo;

FROM IO IMPORT WrStr,WrLn,RdStr,RdKey,RdChar,WrChar,RdCard,WrCard;
FROM Window IMPORT Clear;
FROM Vuelo IMPORT Crear,InsertaVuelo,InsertaPersona,Visualizar,VisualizarVuelo,
                   Destruir,EliminarP,EliminarV,TipoVuelo,TipoCadena,TipoDni,
                   TipoNumV,TipoPasajero,ERROR,DatosVuelo,DatosPersona;

VAR
  v:TipoVuelo;
  error:ERROR;
  op,sal,basura:CHAR;
  avion:DatosVuelo;
  pasajero:DatosPersona;
  numv:TipoNumV;

PROCEDURE Ini():CHAR;
VAR
  opcion:CHAR;
BEGIN
              Clear;
              WrStr('1 - Introducir un vuelo');WrLn;
              WrStr('2 - Introducir un pasaje');WrLn;
              WrStr('3 - Visualizar todo');WrLn;
              WrStr('4 - Visualizar un vuelo');WrLn;
              WrStr('5 - Eliminar un vuelo');WrLn;
              WrStr('6 - Eliminar un pasaje');WrLn;
              WrStr('7 - Destruir');WrLn;
              WrStr('S - Salir (S/N)');WrLn;
              opcion:=RdKey();
              WrChar(opcion);
              RETURN (opcion);
END Ini;

PROCEDURE VerError(e:ERROR);
BEGIN
              CASE e OF
                   |SinError  :;
                   |SinMemo   :WrLn;WrStr('--- Error, no hay memoria ---');
                   |Vacio     :WrLn;WrStr('--- Error, esta vacia ---');
                   |YaTaVuelo :WrLn;WrStr('--- Error, el vuelo ya esta ---');
                   |NoVuelo   :WrLn;WrStr('--- Error, no esta el vuelo ---');
                   |YaTaPersona :WrLn;WrStr('--- Error, el pasajero ya esta ---');
                   |NoPersona :WrLn;WrStr('--- Error, el pasajero no esta ---');
                   |Vlleno    :WrLn;WrStr('--- Error, el vuelo esta lleno ---');
              END;
END VerError;


BEGIN
    Crear(v);
    REPEAT
         op:=Ini();WrLn;
         CASE CAP(op) OF
            |  '1' : WrStr('Introduce un nombre del vuelo : ');
                     RdStr(avion.numvuelo);
                     WrStr('Introduce numero de pasajes : ');
                     avion.libres:=RdCard();
                     InsertaVuelo(v,avion,error);
                     VerError(error);
            |  '2' : WrStr('Introduce el nombre del pasajero : ');
                     RdStr(pasajero.nombre);
                     WrStr('Introduce el DNI : ');
                     RdStr(pasajero.dni);
                     WrStr('Introduce la edad : ');
                     pasajero.edad:=RdCard();
                     WrStr('Introduce el numero del vuelo : ');
                     RdStr(numv);
                     InsertaPersona(v,pasajero,numv,error);
                     VerError(error);
            |  '3' : Visualizar(v);
            |  '4' : WrStr('Introduce el numero del vuelo : ');
                     RdStr(numv);
                     VisualizarVuelo(v,numv,error);
                     VerError(error);
            |  '5' : WrStr('Introduce el numero del vuelo : ');
                     RdStr(numv);
                     EliminarV(v,numv,error);
                     VerError(error);
            |  '6' : WrStr('Introduce el DNI : ');
                     RdStr(pasajero.dni);
                     WrStr('Introduce el numero del vuelo : ');
                     RdStr(numv);
                     EliminarP(v,pasajero.dni,numv,error);
                     VerError(error);
            |  '7' : Destruir(v);
            |  'S' : WrStr('Estas seguro que quires salir (S/N) : ');
                     sal:=RdKey();
         ELSE
            WrLn;
            WrStr('Error en la opcion');WrLn;
         END;
         IF CAP(op)#'S' THEN
            WrLn;
            WrStr('Pulsa una tecla ');
            basura:=RdKey();
         ELSE
            WrLn;
            WrStr("Hasta luego Luuuucas,...,a ver si aprobamos todos ");
            WrLn;
         END
    UNTIL CAP(sal)='S';
END Dvuelo.


